/**
 * DevExtreme (integration/jquery/deferred.js)
 * Version: 17.2.0 (build 17231)
 * Build date: Sat Aug 19 2017
 *
 * Copyright (c) 2012 - 2017 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var $ = require("jquery"),
    typeUtils = require("../../core/utils/type");
exports.fromPromise = function(promise, context) {
    var isDeferred = promise && typeUtils.isFunction(promise.done) && typeUtils.isFunction(promise.fail);
    if (isDeferred) {
        return promise
    }
    var d = $.Deferred();
    promise.then(function() {
        d.resolveWith.apply(d, [context].concat([
            [].slice.call(arguments)
        ]))
    }, function() {
        d.rejectWith.apply(d, [context].concat([
            [].slice.call(arguments)
        ]))
    });
    return d
};
